// Inspired by Anti-debug from rootkit.com
// http://www.rootkit.com/newsread.php?newsid=284
#include <ntddk.h>
#include <WinDef.h>
#include <ntstrsafe.h>
#include "sysdefs.h"
#include "librootkit.h"
#include "adhd.h"

MappedRegion DebugEntry[2];
MappedRegion OrigDebugEntry[2];

// 4 nops are found after each of the functions. 
// If we go a bit too far, it's OK.
const ULONG FUNC_EPILOG = 0x90909090;
#define MAX_ASM_LEN 	128

int ResetDebug(HANDLE ProcessHandle)
{
	NTSTATUS stat;
	BOOL oldDebugValue = 0;
	MPEB *peb = (MPEB*)GetPebForHandleExternal(ProcessHandle);

	if (peb) {
		BOOL tmp;
		BOOL *tebPtr = BorrowBytesFromTeb(&tmp, sizeof(tmp));
		*tebPtr = 0;
		
		// Read debugged pointer
		stat = sa.ZwReadVirtualMemory(ProcessHandle, &peb->BeingDebugged,
			   	tebPtr, 1, NULL);

		if (!NT_SUCCESS(stat)) {
			LR_WARN(("WRN: Can't read BeingDebugged flag of %x: %x\n", 
						ProcessHandle, stat));
			return 0;
		}
		
		oldDebugValue = *tebPtr;
		*tebPtr = 0;

		//write to the BeingDebugged flag within the remote processes PEB
		stat = sa.ZwWriteVirtualMemory(ProcessHandle, &peb->BeingDebugged,
			   	tebPtr, 1, NULL);

		ReturnBytesToTeb(tebPtr, &tmp, sizeof(tmp));

		if(!NT_SUCCESS(stat)) {
			LR_WARN(("WRN: ResetDebug - Failed to write to PEB in remote process: 0x%x\r\n", stat));
			return oldDebugValue;
		}
		LR_DEBUG(("DBG: Successfully reset DEBUG flag for %x\n", ProcessHandle));
	} else {
		LR_WARN(("WRN: ResetDebug - Cannot touch PEB\r\n"));
	}
	
	return oldDebugValue;
}

int ResetPPID(HANDLE ProcHandle)
{
	PLIST_ENTRY Start;
	PLIST_ENTRY Entry;
	MEPROCESS *current;
	ULONG pid;
	ULONG newPPID = 0;
	NTSTATUS stat;
	int ret = 0;
	
	pid = GetProcessIDForHandle(ProcHandle);
	stat = PsLookupProcessByProcessId(pid, &current);
	if(!NT_SUCCESS(stat)) {
		LR_WARN(("WRN: Cannot find process id %d: %x\n", pid, stat));
		return 0;
	}

	Start = &current->ActiveProcessLinks;

	// XXX: Concurrency issues.. Need PEB lock
	BigKernelLock();
	for(Entry = Start->Flink; Entry && Entry != Start; Entry = Entry->Flink) {
		MEPROCESS *p = (MEPROCESS *)CONTAINING_RECORD(Entry, 
				MEPROCESS, ActiveProcessLinks);
		if(_stricmp(p->ImageFileName, "explorer.exe") == 0) {
			newPPID = p->PID;
			ret = 1;
			break;
		}
	}
	BigKernelUnLock();

	if (!Entry) {
		LR_WARN(("WRN: Hit NULL in process list!!!!\r\n"));
	} 

	if(!newPPID) {
		LR_WARN(("WRN: Did not find explorer! We are: %d\r\n", current->PID));
	}

	if(newPPID != current->PPID) {
		LR_NOTE(("NOT: Parent PID reset from %d to %d\r\n", current->PPID, 
				newPPID));
		current->PPID = newPPID;
	} else {
		LR_NOTE(("NOT: Parent already is explorer\r\n"));
	}

	return ret;
}

NTSTATUS NTAPI NewZwCreateProcessEx (OUT PHANDLE ProcessHandle,IN ACCESS_MASK DesiredAccess,IN POBJECT_ATTRIBUTES ObjectAttributes OPTIONAL,IN HANDLE ParentProcessHandle,IN BOOLEAN InheritObjectTable,IN HANDLE SectionHandle,IN HANDLE DebugPort,IN HANDLE ExceptionPort,IN HANDLE Unknown)
{
	NTSTATUS status;

	status = sa.ZwCreateProcessEx(ProcessHandle, 
			//DesiredAccess|PROCESS_ALL_ACCESS, 
			DesiredAccess,
			ObjectAttributes,
			ParentProcessHandle,InheritObjectTable, 
			SectionHandle,DebugPort, ExceptionPort,Unknown);

	if(NT_SUCCESS(status)) {
		if(ResetDebug(*ProcessHandle)) {
			LR_DEBUG(("DBG: Found a debugee. Resetting parent pid\n"));
			ResetPPID(*ProcessHandle);
		}
	} else {
		LR_WARN(("WRN: ZwCreateProcessEx - Failed to create process with error 0x%08X\r\n",status));
	}

	return status;
}


// Debuggers will not be able to attach after a crash with this
// Attaching to a live process seems OK tho.
NTSTATUS NTAPI NewZwQueryInformationProcess(HANDLE ProcessHandle,PROCESSINFOCLASS ProcessInformationClass,PVOID ProcessInformation,ULONG ProcessInformationLength,PULONG ReturnLength)
{
	NTSTATUS status;

	status = sa.ZwQueryInformationProcess(ProcessHandle,ProcessInformationClass,ProcessInformation,ProcessInformationLength,ReturnLength);

	if(NT_SUCCESS(status)) {
		//check to see if an application is querying wether it's debug port is set
		//and do some sanity checks also just in case
		if(ProcessInformationClass == ProcessDebugPort 
				&& ProcessInformation != NULL && ProcessInformationLength >= 4) {
			LR_NOTE(("NOT: ZwQueryInformationProcess - ProcessDebugPort request for %p - setting to NULL (was %x)\r\n", ProcessHandle, *(ULONG *)ProcessInformation));
			*(ULONG*)ProcessInformation = 0;	//forcefuly set port to 0 to that calling applications
												//assumes no debugger is attached
		}
	}

	return status;
}

NTSTATUS NTAPI NewZwDebugActiveProcess(IN HANDLE proc, IN HANDLE dbgobj)
{
	NTSTATUS status;

	status = sa.ZwDebugActiveProcess(proc, dbgobj);

	if(NT_SUCCESS(status)) {
		if(ResetDebug(proc)) {
		// Shouldn't be needed..
		//	ResetPPID(proc);
		}
	}

	return status;
}

NTSTATUS (NTAPI *OldNtSetInformationThread)(HANDLE Handle,
		THREADINFOCLASS InfoClass, PVOID Info, ULONG InfoLen);

NTSTATUS NTAPI NewNtSetInformationThread(HANDLE Handle,
		THREADINFOCLASS InfoClass, PVOID Info, ULONG InfoLen)
{
	if(InfoClass == ThreadHideFromDebugger) {
		NTSTATUS stat;
		PVOID tmp;
		PVOID tebStart;
		
		if(InfoLen !=  0) {
			return STATUS_INFO_LENGTH_MISMATCH;
		}
	   	tebStart = BorrowBytesFromTeb(&tmp, sizeof(tmp));

		// Make sure Handle exists!1
		stat = sa.NtQueryInformationThread(Handle, 
				ThreadQuerySetWin32StartAddress, 
				tebStart, sizeof(PVOID), 0);

		ReturnBytesToTeb(tebStart, &tmp, sizeof(tmp));

		if(!NT_SUCCESS(stat)) {
			LR_NOTE(("NOT: Bozos tried to call us with an invalid thread\n"));
			return stat;
		}
		
		LR_NOTE(("NOT: ThreadHideFromDebugger called. Denying\n"));
		return 0;
	}

	return OldNtSetInformationThread(Handle, InfoClass, Info, InfoLen);
}

NTSTATUS NewZwCreateThread(OUT PHANDLE ThreadHandle, 
		IN ACCESS_MASK DesiredAccess, 
		IN POBJECT_ATTRIBUTES ObjectAttributes  OPTIONAL, 
		IN HANDLE ProcessHandle, OUT PCLIENT_ID ClientId, 
		IN PCONTEXT ThreadContext, IN PVOID InitialTeb, 
		IN BOOLEAN CreateSuspended)
{
	MappedRegion *r;
	LR_DEBUG(("DBG: ZwCreateThread(%x)\r\n", ThreadContext->Eip));

	// XXX: hrmm.. walk imports table using GetProc..
	if (r = find_region(DebugEntry, sizeof(DebugEntry)/sizeof(DebugEntry[0]), 
				ThreadContext->Eip)) {
		LR_DEBUG(("DBG: ZwCreateThread: %x vs %x for idx %d\r\n", ThreadContext->Eip,
					r->base, r-DebugEntry));
		if(ThreadContext->Eip == r->base && OrigDebugEntry[r-DebugEntry].base) {
			UCHAR scratch[MAX_ASM_LEN];
			PVOID asmbuf = BorrowBytesFromTeb((PVOID)scratch, sizeof(scratch));
			NTSTATUS intstat = sa.ZwReadVirtualMemory(ProcessHandle, 
					(PVOID)ThreadContext->Eip, asmbuf, r->extent, NULL);

			if (NT_SUCCESS(intstat)) {
				if (memcmp(asmbuf, (PVOID)OrigDebugEntry[r-DebugEntry].base, 
							r->extent) != 0) {
					DWORD *tebptr = (DWORD*)asmbuf;
					DWORD old_perms;
					LR_NOTE(("NOT: Debug hooks have changed! Rewriting\r\n"));

					tebptr[0] = ThreadContext->Eip & 0xFFFFF000;
					tebptr[1] = 4096;
					tebptr[2] = 0;
					intstat = sa.ZwProtectVirtualMemory(ProcessHandle, 
							(PVOID*)&tebptr[0], &tebptr[1], 
							PAGE_EXECUTE_READWRITE, &tebptr[2]);
					old_perms = tebptr[2];

					if(!NT_SUCCESS(intstat)) {
						LR_WARN(("WRN: VirtualProtect(%x) failed: %x\n", 
									tebptr[0], intstat));
					}
					
					memcpy(asmbuf, (PVOID)OrigDebugEntry[r-DebugEntry].base, 
							r->extent);
					intstat = sa.ZwWriteVirtualMemory(ProcessHandle, 
							(PVOID)ThreadContext->Eip, 
							asmbuf, r->extent, NULL);

					if (!NT_SUCCESS(intstat)) {
						LR_WARN(("WRN: Write memory failed: %x\r\n", intstat));
					}

					tebptr[0] = ThreadContext->Eip & 0xFFFFF000;
					tebptr[1] = 4096;
					tebptr[2] = 0;
					intstat = sa.ZwProtectVirtualMemory(ProcessHandle, 
							(PVOID*)&tebptr[0], &tebptr[1], old_perms, 
							&tebptr[2]);

					if(!NT_SUCCESS(intstat)) {
						LR_WARN(("WRN: VirtualUnProtect(%x) failed: %x\n", 
									tebptr[0], intstat));
					}
				}
			} else {
				LR_WARN(("WRN: Read memory failed: %x\r\n", intstat));
			}
			ReturnBytesToTeb(asmbuf, scratch, sizeof(scratch));
		}
	}
	
	return sa.ZwCreateThread(ThreadHandle, DesiredAccess, ObjectAttributes,
			ProcessHandle, ClientId, ThreadContext, InitialTeb,
			CreateSuspended);
}

void SetupDbgBreakin(HANDLE ntdll)
{
	DWORD DbgUiRemoteBreakin = KGetProcAddress(ntdll, "DbgUiRemoteBreakin");
	DWORD DbgBreakPoint = KGetProcAddress(ntdll, "DbgBreakPoint");
	UCHAR *scanptr;
	int i = 0;

	LR_DEBUG(("DBG: Found DbgUI: %x and DbgBP: %x\n", DbgUiRemoteBreakin,
				DbgBreakPoint));

	if (ProbeForReadStatus((PVOID)DbgUiRemoteBreakin, MAX_ASM_LEN, 1) || 
			ProbeForReadStatus((PVOID)DbgBreakPoint, MAX_ASM_LEN, 1)) {
		LR_NOTE(("NOT: Address %x or %x not valid\r\n", 
					DbgUiRemoteBreakin,
					DbgBreakPoint));
		return;
	}

	DebugEntry[0].base = DbgUiRemoteBreakin;
	DebugEntry[1].base = DbgBreakPoint;

	scanptr = (UCHAR*)DbgUiRemoteBreakin;
	for(i = 0; *(ULONG *)&scanptr[i] != FUNC_EPILOG && i < MAX_ASM_LEN; i++)
		;
	LR_DEBUG(("DBG: DbgUiRemoteBreakin len is %d\r\n", i));
	
	OrigDebugEntry[0].extent = DebugEntry[0].extent = i;

	scanptr = (UCHAR*)DbgBreakPoint;
	for(i=0; *(ULONG *)&scanptr[i] != FUNC_EPILOG && i < MAX_ASM_LEN; i++)
		;
	
	LR_DEBUG(("DBG: DbgBreakPoint len is %d\r\n", i));
	OrigDebugEntry[1].extent = DebugEntry[1].extent = i;

	if ((OrigDebugEntry[0].base = (ULONG)ExAllocatePoolWithTag(PagedPool, 
					OrigDebugEntry[0].extent, 'ADHD')) != 0) {
		memcpy((PVOID)OrigDebugEntry[0].base, (PVOID)DebugEntry[0].base, 
				DebugEntry[0].extent);
	}

	if ((OrigDebugEntry[1].base = (ULONG)ExAllocatePoolWithTag(PagedPool, 
					OrigDebugEntry[1].extent, 'ADHD')) != 0) {
		memcpy((PVOID)OrigDebugEntry[1].base, (PVOID)DebugEntry[1].base, 
				DebugEntry[1].extent);
	}
}

void FreeDbgBreakin()
{
	ExFreePoolWithTag((PVOID)OrigDebugEntry[0].base, 'ADHD');
	ExFreePoolWithTag((PVOID)OrigDebugEntry[1].base, 'ADHD');
}


NTSTATUS UnHookServiceAPI()
{
	HANDLE ntdll;

	if(!(ntdll = KLoadLibrary(L"\\??\\c:\\Windows\\System32\\ntdll.dll"))) {
		LR_WARN(("WRN: Can't open ntdll!\n"));
	}

	//dissable interrupt while we change the pointers and make tabe writable
	_asm {
		CLI 
		MOV	EAX, CR0
		AND 	EAX, NOT 10000H
		MOV	CR0, EAX
	}

	//change service table pointers to the originals
	
	(ZWQUERYINFORMATIONPROCESS)(SYSTEM_SERVICE(ZwQueryInformationProcess)) = sa.ZwQueryInformationProcess;

	//enable interrupts with the new pointers inplace
	_asm {
		MOV	EAX, CR0
		OR	EAX, 10000H
		MOV	CR0, EAX
		STI
	}

	HookSyscall(ntdll, "ZwCreateProcessEx", (DWORD)sa.ZwCreateProcessEx);
	HookSyscall(ntdll, "ZwCreateThread", (DWORD)sa.ZwCreateThread);
	HookSyscall(ntdll, "ZwDebugActiveProcess", (DWORD)sa.ZwDebugActiveProcess);
	HookSyscall(ntdll, "NtSetInformationThread", (DWORD)OldNtSetInformationThread);

	FreeDbgBreakin();
	KFreeLibrary(ntdll);

	return STATUS_SUCCESS;
}


NTSTATUS HookServiceAPI()
{
	HANDLE ntdll;
	
	if(!(ntdll = KLoadLibrary(L"\\??\\c:\\Windows\\System32\\ntdll.dll"))) {
		LR_WARN(("WRN: Can't open ntdll!\n"));
	}
	LR_DEBUG(("DBG: Ntdll @ %x\n", ntdll));

	__asm {
		CLI 
		MOV	EAX, CR0
		AND EAX, NOT 10000H
		MOV	CR0, EAX
	}

	//change service table pointers to our version
	(ZWQUERYINFORMATIONPROCESS)(SYSTEM_SERVICE(ZwQueryInformationProcess)) = NewZwQueryInformationProcess;

	__asm {
		MOV	EAX, CR0
		OR	EAX, 10000H
		MOV	CR0, EAX
		STI
	}
	
	HookSyscall(ntdll, "ZwCreateProcessEx", (DWORD)NewZwCreateProcessEx);
	HookSyscall(ntdll, "ZwCreateThread", (DWORD)NewZwCreateThread);
	HookSyscall(ntdll, "ZwDebugActiveProcess", (DWORD)NewZwDebugActiveProcess);
	
	(DWORD)OldNtSetInformationThread = 
		HookSyscall(ntdll, "NtSetInformationThread", 
				(DWORD)NewNtSetInformationThread);

	SetupDbgBreakin(ntdll);
	KFreeLibrary(ntdll);
	return STATUS_SUCCESS;
}

NTSTATUS DriverExit(IN PDRIVER_OBJECT  DriverObject)
{
   	UNICODE_STRING          deviceLinkUnicodeString;
	PDEVICE_OBJECT			p_NextObj;
	LARGE_INTEGER			pDelay;

	UnHookServiceAPI();

	LR_NOTE(("NOT: ADHD Exit\r\n"));

	pDelay.QuadPart = -5000000;
	KeDelayExecutionThread(KernelMode,TRUE,&pDelay);
	return STATUS_SUCCESS;
}

NTSTATUS DriverEntry( IN PDRIVER_OBJECT DriverObject, IN PUNICODE_STRING theRegistryPath )
{
	NTSTATUS status = STATUS_SUCCESS;
	UNICODE_STRING ufname, ulname;

	DbgPrint("ADHD Loaded @ IRQL %d\r\n", KeGetCurrentIrql());
	DriverObject->DriverUnload  = DriverExit; 
	
	if(KeGetCurrentIrql() != 0) {
		LR_WARN(("WRN: IRQL %d at driver entry!\n", KeGetCurrentIrql()));
		return 0;
	}

	LibRootkit_Init();
	HookServiceAPI();

	return status;
}
